#include <stdio.h>

static char map[80][80];
static int x, y;

static void putmap(int i, int j, char c)
{
  if(1<=i && i<=x && 1<=j && j<=y)
  {
    if(c==' ')
    {
      map[i][j]=' ';
      return;
    }
  
    if(map[i][j]==c)
      return;
    
    if(map[i][j]==' ')
    {
      map[i][j]=c;
      return;
    }
    
    if((map[i][j]=='-' || map[i][j]=='|' || map[i][j]=='+') && (c=='-' || c=='|'))
    {
      map[i][j]='+';
      return;
    }

    if((map[i][j]=='\\' || map[i][j]=='/' || map[i][j]=='x') && (c=='\\' || c=='/'))
    {
      map[i][j]='x';
      return;
    }
    
    map[i][j]='*';
  }
}


static void point()
{
  int i, j;

  scanf("%d %d ", &i, &j);
  putmap(i, j, 'o');
}

static void text()
{
  static char tmp[16384];
  int i, j;
  char *c;

  scanf("%d %d %s ", &i, &j, tmp);
  c=tmp;
  
  while(*c)
  {
    putmap(i, j, *c);
    c++;
    i++;
  }
}


static void justify(int *x, int *y)
{
  int tmp;

  if(*x<*y)
    return;
  
  tmp=*x;
  *x=*y;
  *y=tmp;
}


static void line()
{
  int x1, y1, x2, y2, i, j;
  
  scanf("%d %d %d %d ", &x1, &y1, &x2, &y2);
  
  if(x1>x2)
  {
    i=x1;
    x1=x2;
    x2=i;
    
    i=y1;
    y1=y2;
    y2=i;
  }
  
  if(x1==x2)
  {
    if(y1>y2)
    {
      i=y1;
      y1=y2;
      y2=i;
    }
    
    for(i=y1; i<=y2; i++)
      putmap(x1, i, '|');
  }
   else
  if(y1==y2)
  {
    for(i=x1; i<=x2; i++)
      putmap(i, y1, '-');
  }
   else
  if(y1<y2)
  {
    for(i=x1; i<=x2; i++)
      putmap(i, y1+i-x1, '\\');
  }
   else
  {
    for(i=x1; i<=x2; i++)
      putmap(i, y1+x1-i, '/');
  }
}



static void clear()
{
  int x1, y1, x2, y2, i, j;
  
  scanf("%d %d %d %d ", &x1, &y1, &x2, &y2);
  
  justify(&x1, &x2);
  justify(&y1, &y2);
  
  for(i=x1; i<=x2; i++)
    for(j=y1; j<=y2; j++)
      putmap(i, j, ' ');
}


int main()
{
  char cmd[10];
  int i, j;

  scanf("%d %d ", &x, &y);
  
  while(x || y)
  {
    memset(map, 32, sizeof(map));
    map[0][0]='+';
    map[x+1][0]='+';
    map[0][y+1]='+';
    map[x+1][y+1]='+';
    
    for(i=1; i<=x; i++)
    {
      map[i][0]='-';
      map[i][y+1]='-';
    }

    for(i=1; i<=y; i++)
    {
      map[0][i]='|';
      map[x+1][i]='|';
    }
    
    while(1)
    {
      scanf("%s ", cmd);
      
      if(!strcmp(cmd, "POINT"))
        point();
       else
      if(!strcmp(cmd, "TEXT"))
        text();
       else
      if(!strcmp(cmd, "LINE"))
        line();
       else
      if(!strcmp(cmd, "CLEAR"))
        clear();
       else
      if(!strcmp(cmd, "PRINT"))
      {
        for(j=0; j<=y+1; j++)
        {
          for(i=0; i<=x+1; i++)
            printf("%c", map[i][j]);
          
          printf("\n");
        }

        printf("\n");
        
        break;
      }
    }
     
    scanf("%d %d ", &x, &y);
  }
  
  
  return 0;
}
